<template>
  <basic-container>
    <avue-crud :option="option"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.post_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot-scope="{row}"
                slot="category">
        <el-tag>{{row.categoryName}}</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {getList, getDetail, add, update, remove} from "@/api/system/post";
import {mapGetters} from "vuex";

export default {
  data() {
    return {
      form: {},
      query: {},
      loading: true,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        height: 'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        viewBtn: true,
        selection: true,
        dialogType: "drawer",
        dialogClickModal: false,
        column: [
          {
            "label": "慰问年度",
            "prop": "weiwenniandu",
            "type": "year",
            "span": 24,
            "format": "yyyy",
            "valueFormat": "yyyy",
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "慰问年度必须填写"
              }
            ]
          },

          {
            "label": "单位",
            "prop": "danwei",
            "type": "select",
            "span": 12,
            "dicData": [
              {
                "label": "上海市司法局",
                "value": "0"
              },
              {
                "label": "上海市监狱局",
                "value": "1"
              },
              {
                "label": "上海市戒毒局",
                "value": "2"
              }
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "单位必须填写"
              }
            ]
          },

          {
            "label": "部门",
            "prop": "bumen",
            "type": "select",
            "span": 12,
            "dicData": [
              {
                "label": "信息技术处",
                "value": "0"
              },
              {
                "label": "政治部",
                "value": "1"
              },
              {
                "label": "人事警务处",
                "value": "2"
              }
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "部门必须填写"
              }
            ]
          },

          {
            "label": "慰问类型",
            "prop": "weiwenleixing",
            "type": "select",
            "span": 24,
            "dicData": [
              {
                "label": "不可抗力",
                "value": "0"
              },
              {
                "label": "个人因病",
                "value": "1"
              },
              {
                "label": "家庭因病",
                "value": "2"
              },
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "慰问类型必须填写"
              }
            ]
          },


          {
            "label": "申请人",
            "prop": "shenqingren",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "required": false,
          },


          {
            "label": "情况说明",
            "prop": "qingkuangshuoming",
            "type": "textarea",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "情况说明必须填写"
              }
            ]

          },
          {
            "label": "附件",
            "prop": "fujian",
            "type": "upload",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "hide":true,
          },
        ]
      },
      data: [
        {
          weiwenniandu: '2022',
          danwei:'上海市司法局',
          bumen: 'xxx处',
          weiwenleixing: '不可抗力',
          shenqingren:'王老师',
          qingkuangshuoming:'遭遇交通事故，对方逃逸。',
          fujian:'',
        },
        {
          weiwenniandu: '2022',
          danwei:'上海市司法局',
          bumen: 'yyy处',
          weiwenleixing: '个人因病',
          shenqingren:'李老师',
          qingkuangshuoming:'胃癌晚期',
          fujian:'',
        },
      ]
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.post_add, false),
        viewBtn: this.vaildData(this.permission.post_view, false),
        delBtn: this.vaildData(this.permission.post_delete, false),
        editBtn: this.vaildData(this.permission.post_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.$refs.crud.toggleSelection();
        });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
